/* multipipe2.c - A pipe1-t es a pipe2-t olvassa felvaltva, nem 
   blokkolt modban. */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

int main(void)
{
  int fds[2];
  char buf[2048];
  int fdix;
  int res;

  /* Olvasasra megnyitjuk a pipe1 es pipe2 allomanyokat, ha 
     leteznek. */
  if((fds[0]=open("pipe1", O_RDONLY | O_NONBLOCK)) < 0)
  {
    perror("open pipe1");
    return 1;
  }
  if((fds[1]=open("pipe2", O_RDONLY | O_NONBLOCK)) < 0)
  {
    perror("open pipe2");
    return 1;
  }

  fdix=0;
  while(1)
  {
    /* Ha az adat rendelkezesre all beolvassuk es 
       megjelenitjuk */
    res=read(fds[fdix], buf, sizeof(buf) - 1);
    if(res > 0)
    {
      buf[res] = '\0';
      printf("Pipe%d: %s", fdix+1, buf);
    } 
    else if(res == 0)
    {
      printf("A pipe%d lezarult\n", fdix+1);
      return 0;
    } 
    else if((res < 0) && (errno != EAGAIN))
    {
      perror("read");
      return 1;
    } 

    /* A masik leiro kerul sorra. */
    fdix=(fdix+1)%2;
  }
}
