/* multipipe3.c - A pipe1-t es a pipe2-t olvassa parhuzamosan, a 
   select() metodussal. */ 

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>

int main(void) 
{
  int fds[2];
  char buf[2048];
  int i, res, maxfd;
  fd_set watchset; /* A figyelendo leirok. */
  fd_set inset; /* A select() metodus altal frissitett lista. */

  /* Olvasasra megnyitjuk a pipe1 es pipe2 allomanyokat, ha 
     leteznek. */
  if((fds[0]=open("pipe1", O_RDONLY | O_NONBLOCK)) < 0)
  {
    perror("open pipe1");
    return 1;
  }
  if((fds[1]=open("pipe2", O_RDONLY | O_NONBLOCK)) < 0)
  {
    perror("open pipe2");
    return 1;
  }

  /* A ket leirot elhelyezzuk a listaban. */
  FD_ZERO(&watchset);
  FD_SET(fds[0], &watchset);
  FD_SET(fds[1], &watchset);
 
  /* Kiszamoljuk a legnagyobb leiro erteket. */
  maxfd=fds[0] > fds[1] ? fds[0] : fds[1];

  /* A ciklus addig tart amig legalabb egy leirot figyelunk. */
  while(FD_ISSET(fds[0], &watchset) || 
    FD_ISSET(fds[1], &watchset))
  {
    /* Lemasoljuk a leiro listat, mert a select() metodus 
       modositja. */
    inset=watchset;
    if(select(maxfd + 1, &inset, NULL, NULL, NULL) < 0)
    {
      perror("select");
      return 1;
    } 

    /* Ellenorizzuk mely leiro tartalmaz olvashato adatot. */
    for(i=0; i < 2; i++)
    {
      if(FD_ISSET(fds[i], &inset))
      {
        /* Az fds[i] olvashato, ezert olvassuk is. */
        res = read(fds[i], buf, sizeof(buf) - 1);
        if(res > 0)
        {
          buf[res] = '\0';
          printf("Pipe%d: %s", i+1, buf);
        }
        else if(res == 0)
        {
          /* A pipe-ot lezartak. */
          close(fds[i]);
          FD_CLR(fds[i], &watchset);
        } 
        else
        {
          perror("read");
          return 1;
        }
      }
    } 
  }

  return 0;
}
