/* serial2.c - Nem kanonikus soros port kezeles. */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#define BAUDRATE B38400
#define MODEMDEVICE "/dev/ttyS1"

#define FALSE 0
#define TRUE 1
        
volatile int STOP=FALSE; 
       
int main(void)
{
  int fd,res;
  struct termios oldtio,newtio;
  char buf[255];
        
  fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY ); 
  if(fd < 0) { perror(MODEMDEVICE); exit(-1); }
        
  tcgetattr(fd, &oldtio);
        
  bzero(&newtio, sizeof(newtio));
  newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
  newtio.c_iflag = IGNPAR;
  newtio.c_oflag = 0;

  /* Az input beallitas nem kanonikus es a visszejelzest is 
     kikapcsoljuk. */        
  newtio.c_lflag = 0;

  /* A karakterek kozti idozitot nem hasznaljuk. */         
  newtio.c_cc[VTIME]    = 0;
  /* Az olvasas blokkolodik, amig 5 karakter erkezik. */
  newtio.c_cc[VMIN]     = 5;

  tcflush(fd, TCIFLUSH);
  tcsetattr(fd, TCSANOW, &newtio);
        
  while (STOP==FALSE) 
  {
    /* 5 karakter beolvasasa utan visszater. */
    res = read(fd, buf, 255);
    buf[res] = 0;
    printf(":%s:%d\n", buf, res);
    if(buf[0] == 'z') STOP = TRUE;
  }
  tcsetattr(fd, TCSANOW, &oldtio);

  return 0;
}
