#include <signal.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/select.h>
#include <sys/signalfd.h>
#include <fcntl.h>

int main()
{

	sigset_t alarmMask, fullMask;
	int fd;
	struct signalfd_siginfo info;
	int ret;

	sigemptyset(&alarmMask);
	sigaddset(&alarmMask, SIGALRM);
	
	// Az osszes jelzes letiltása
	sigfillset(&fullMask);
        sigprocmask(SIG_BLOCK, &fullMask, NULL);
	
	fd = signalfd(-1, &alarmMask, SFD_NONBLOCK);
	

	alarm(10); // 10 masodperc múlva SIGALRM jelzés
	
	// A select az stdinnre es a jelzes leirojara figyel
	fd_set readfds;
	FD_SET(STDIN_FILENO, &readfds);
	FD_SET(fd, &readfds);

	select(fd+1, &readfds, NULL, NULL, 0);
	
	if(FD_ISSET(fd, &readfds))
	{		
		ret = read(fd, &info, sizeof(struct signalfd_siginfo));
		printf("%d processz jelzest kuldott.\n", info.ssi_pid);
	}

	close(fd);

	printf("Megerkezett vagy megnyomtak.\n");


	return(alarm(0)); // Kikapcsoljuk az idozitot
}

