/* shmem.c - Megosztott memoria letrehozasa. */

#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <stdlib.h>
#include "kozos.h"

int main()
{
  int shmid;
  char c;
  char* shmptr;

  /* A megosztott memoria letrehozasa. */
  if((shmid = shmget(SHM_ID, MEMORY_SIZE, IPC_CREAT|0666)) < 0) 
  {
    fprintf(stderr,"Hiba a megosztott memoria letrehozasanal.\n");
    exit(1);
  }

  /* A megosztott memoria felcsatolasa. */
  if((shmptr=shmat(shmid,0,0))==(char*)-1)
  {
    fprintf(stderr,"Hiba a megosztott memoria "
      "felcsatolasanal.\n");
    exit(1);
  }

  printf("Adatok irasa a megosztott memoriaba...\n");
  for(c=0; c < 9; c++)
  {
    shmptr[c]='1'+c;  /*123456789*/
  }
  shmptr[9]='\0';

  printf("Nyomj <Enter>-t a folytatashoz!\n");
  getchar();

  /* A megosztott memoria lecsatolasa. */
  shmdt(shmptr);

  /* A megosztott memoria megszuntetese. */
  shmctl(shmid, IPC_RMID, 0);

  return 0;
}
