/* shmrd.c - Megosztott memoria kiolvasasa. */

#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <stdlib.h>
#include "kozos.h"

int main()
{
  int shmid;
  char* shmptr;

  /* A mar letezo megosztott memoria leirojanak lekerdezese. */
  shmid = shmget(SHM_ID, MEMORY_SIZE, 0666);
  if (shmid < 0) 
  {
    fprintf(stderr,"Hiba a megosztott memoriahoz valo "
      "hozzaferesben.\n");
    exit(1);
  }

  /* A megosztott memoria felcsatolasa. */
  shmptr=shmat(shmid,0,0);
  if(shmptr==(char*)-1)
  {
    fprintf(stderr,"Hiba a megosztott memoria "
      "felcsatolasanal.\n");
    exit(1);
  }

  printf("A megosztott memoria tartalma: %s\n",shmptr);

  /* A megosztott memoria lecsatolasa. */
  shmdt(shmptr);

  return 0;
}
