/* legitarsasag.c - Pelda a szemaforok hasznalatara.
   Utasok bejelentkezese a repteri pultnal. */

#include <sys/ipc.h>
#include <sys/sem.h>
#include <stdio.h>
#include <stdlib.h>
#include "kozos.h"

int semgetval(int semid, int member);
void createsem(int *sid, key_t key, int members);

int main()
{
  int semid;

  /* Generating unique key number for semaphore */
  key_t key = ftok(".", 's');
 
  createsem(&semid,key,SEM_MAX_IN_SET);

  printf("A legitarsasag #%d letrejott %d pulttal.\n",key,SEM_MAX_IN_SET);                                                                        
  printf("Elindult a bejelentekezesi szolgaltatas...\n");
  printf("Nyomj <Enter>-t a kilepeshez!\n");
 
  getchar();

  semctl(semid, 0, IPC_RMID, 0);
  printf("A legitarsasag #%d bezart.\n",key);
                
  return 0;
}


/* Lekerdezi a szemafor aktualis erteket */ 
int semgetval(int semid, int member)
{
  int semval;
        
  semval = semctl(semid, member, GETVAL, 0);
  return semval ;
}



/* Szemafortomb letrehozasa */
void createsem(int *sid, key_t key, int members)
{
  int cntr;
  union semun semopts;

  if(members > SEM_MAX_IN_SET) 
  {
    printf("A legitarsasagok maximalis szama: %d\n",
      SEM_MAX_IN_SET);
    exit(1);
  }

  if((*sid = semget(key, members, IPC_CREAT|IPC_EXCL|0666))== -1) 
  {
    fprintf(stderr, "A legitarsasag mar letezik!\n");
    exit(1);
  }

  semopts.val = SEM_RESOURCE_INIT;

  /* Az osszes tag kezdeti ertekenek beallitasa a kezdeti ertekre
*/        
  for(cntr=0; cntr<members; cntr++)
  {
    semctl(*sid, cntr, SETVAL, semopts);
    printf("%d. szamlalo ertek:%d\n",cntr,semgetval(*sid,cntr));
  }
}
