/* kurzus_szerver.c - A kurzusszerver. */

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <stdio.h>
#include "kozos.h"

/* Max ennyi hallgato jelentkezhet a kurzusra. */
#define MAX_REGISTRATION 5 

int main()
{
  key_t key;
  int   mqid,i;
  struct studentinfo_msg msg;
  struct studentinfo_msg *pmsg=&msg;

  /* Egyedi kulcs letrehozasa ftok() segitsegevel. */
  key=ftok("./",'m');

  /* Az uzenetsor megnyitasa.  */
  if((mqid = msgget(key, IPC_CREAT|0660)) == -1) 
  {
    fprintf(stderr,"A kurzus azonosito #%d nem letezik.\n", key);
    return 1;
  }

  printf("A #%d kurzus fogadja a regisztraciokat.\n", key);
  for(i=0; i < MAX_REGISTRATION; i++)
  {
    pmsg->mtype = MSG_TYPE_REGISTER;
    msgrcv(mqid,(struct msgbuf *)pmsg, sizeof(msg)-sizeof(long), 
      MSG_TYPE_REGISTER, 0);
        
    printf("A kurzusra jelentkezo tanulo adatai:\n");
    printf("Nev: %s\n",pmsg->data.nev);
    printf("Cim: %s\n",pmsg->data.cim);
    printf("Igazolvany szam: %s\n",pmsg->data.igszam);
    printf("Megjegyzes: %s\n\n",pmsg->data.megj);
  }

  /* Uzenetsor torlese. */
  msgctl(mqid, IPC_RMID, 0);

  printf("A regisztracio lezarult.\n");

  return 0;
}
