/* regisztracio.c - A hallgatokat regisztralo kliens. */
/* Parancssori argumentum a kurzus szama.            */

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <stdio.h>
#include <stdlib.h>
#include "kozos.h"

int main (int argc, char* argv[])
{
  key_t key;
  int   mqid;
  struct studentinfo_msg msg;
  int   msgsize;

  if(argc != 2)
  {
    fprintf(stderr,"Hasznalat: "
      "regisztracio <kurzus azonosito>\n");
    return -1;
  }
	
  key=atoi(argv[1]);

  /* Az uzenetsor megnyitasa. */
  if((mqid = msgget(key, 0660)) == -1) 
  {
    fprintf(stderr,"A kurzus azonosito #%d nem letezik.\n", key);
    return 1;
  }
	
  printf("Nev: ");
  scanf("%s",msg.data.nev);

  printf("Cim: ");
  scanf("%s",msg.data.cim);

  printf("Igazolvany szam: ");
  scanf("%s",msg.data.igszam);

  printf("Megjegyzes: ");
  scanf("%s",msg.data.megj);

  /* Uzenetkuldes. */
  printf("Diak regisztralasa ...\n");

  msg.mtype = MSG_TYPE_REGISTER;
    
  /* A hossz az mtype tagvaltozo nelkul ertendo. */
  msgsize=sizeof(struct studentinfo_msg)-sizeof(long);

  if((msgsnd(mqid, (struct msgbuf *)&msg,msgsize, 0)) ==-1)
  {
    fprintf(stderr,"A regisztracio elkuldese sikertelen.\n");
    return -1;
  }

  printf("A diak regisztracioja sikeres.\n");

  return 0;
}
