#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

unsigned int counter=0;

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t condvar = PTHREAD_COND_INITIALIZER;

void *monitor_thread(void *arg) 
{
  printf("A monitorozo szal indul... \n");
 
  pthread_mutex_lock(&mutex);
  while(1)
  {
    if(counter == 10)
    {
      printf("!Figyelem: vizszint!\n");
    }
    else if(counter == 15)
    {
      break;
    }
  	  
    pthread_cond_wait(&condvar, &mutex);	    
  }

  pthread_mutex_unlock(&mutex);	// Kilepeskor elengedni

  printf("!!!Katasztrofa tortent!!!\n");
  

  return NULL;
}

int main() 
{
  pthread_t mythread;
  int i;
  
  if(pthread_create( &mythread, NULL, monitor_thread, NULL))
  {
    fprintf(stderr,"Hiba a szal letrehozasanal.\n");
    exit(1);
  }
 
  pthread_yield();	
  /* Szimulaljuk a vizszint valtozasat. */
  for(i=0;i<20;i++)
  {
    sleep(1);

    pthread_mutex_lock(&mutex); 

    // A szamlalo novelese
    counter++;

    printf("A szamlalo allasa: %u\n", counter); 
    if(counter == 10 || counter==15)
    {	
      printf("Jelzes kuldese...\n");
      pthread_cond_broadcast(&condvar);
      printf("Visszakapjuk a mutexet...\n");
    }
    
    pthread_mutex_unlock(&mutex);	
  }
      
  if(pthread_join(mythread, NULL)) 
  {
    fprintf(stderr,"Hiba a szal megvarasanal.\n");
    exit(1);
  }
  printf("A foszal kilep...\n");
  return 0;
}

