/* posix_sem.c - POSIX szemafor pelda */

#define PULTOK_SZAMA      5
#define KISZOLGALASI_IDO  10 /* masodpercben */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>

/* Globalis valtozok */
sem_t szemafor;
int utas_szamlalo=0;

void* utas_szal(void*arg)
{
  int sorszam=*(int*)arg;
  free(arg);

  printf("A %d. utas sorban all...\n",sorszam);

  /* Varakozunk a szemaforra: innen csak akkor jutunk */
  /* tovabb, ha egy pult szabad lesz */
  sem_wait(&szemafor);

  printf("A %d. utas sorra kerult...\n",sorszam);
  sleep(KISZOLGALASI_IDO);

  printf("A %d. utas tavozott...\n",sorszam);

  /* Elengedjuk a szemafort */
  sem_post(&szemafor);
  return NULL;
}

int main(int argc, char *argv[])
{
  int ch;
  int* p_sorszam;
  pthread_t szal_leiro;

  /* Beallitjuk a szemafor erteket */
  sem_init(&szemafor,0,PULTOK_SZAMA);

  printf("Hasznalat: Nyomjon u-t uj utas kuldesehez, k-t a kilepeshez!\n");
  do
  {    
    do
    {
      ch=getchar();
    }while(ch!='u'&&ch!='k');
    
    utas_szamlalo++;
    p_sorszam=malloc(sizeof(int));
    *p_sorszam=utas_szamlalo;

    pthread_create(&szal_leiro,NULL,utas_szal,p_sorszam);

  }
  while(ch!='k');

  printf("Pultokat bezartak, sorban allok hazamennek...\n");

  return 0;
}
