/* thread.cpp - C++ pelda a szalak hasznalatara. */

#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include "thread.h"

using namespace std;


void Thread::Join()
{	
   if(!started)
    return; 
  if(pthread_join(thread, NULL))
  {
    cerr<<"Hiba a szal megvarasaban.\n";
    exit(1);
  }

  started = false;
}



void Thread::Start()
{
  if(started)
  {
    cerr<< "A szal mar elindult." << endl;
    return; 
  }
  /* Atadjuk a this pointert void* alakban. */
  if(pthread_create(&thread, NULL, ThreadStart,
    (void*)this))
  {
    cerr<<"Hiba a szal letrehozasanal.\n";
    exit(1);
  }
  started = true;
}

void *Thread::ThreadStart(void *pThread)
{

  /* Atvesszuk a this pointert, konvertaljuk az osztaly
     tipusara. */
  Thread* pThis=(Thread*)pThread;

  pThis->ThreadMain();  // Meghivjuk a sz
  
}


// Hasznalata
class MyThread: public Thread
{
 public:
  void 	ThreadMain()
  {
    int i;
 
    cout << "A szal indul..." << endl;
    for ( i=1; i<=20; i++ )  
    {
	cout<< i <<". Hello szal vilag!"<< endl;
	sleep(1);
    }
	cout<< "A szal kilep..."<< endl;
  }

};


int main()
{
  MyThread t;
  t.Start();

  cout<< "Varakozas a tobbi szalra...\n";

  sleep(5);
  
  t.Join();

  printf("A foszal kilep... \n");
  return 0;
}
