#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

static pthread_once_t key_init = PTHREAD_ONCE_INIT;
static pthread_key_t key;

void destructor (void* value)
{
  free(value);
}

void create_key_once()
{
  pthread_key_create(&key, destructor);
}


// Rossz
int delay2(int value)
{
 static int prev = 0;
 int retval = prev;
 prev = value;

 return retval;
}


int delay( int value)
{
  int *ptr, prev;
  pthread_once(&key_init, create_key_once);
  
  ptr = pthread_getspecific(key);

  if(ptr == NULL)
  {
    ptr = malloc(sizeof(int));
    pthread_setspecific(key, ptr);
    prev = 0;
  }
  else
  {
    prev = *ptr;
  }
  
  *ptr= value;   
  
  return prev;
}


static __thread int prev = 0;

int delay3(int value)
{

 int retval = prev;
 prev = value;

 return retval;
}


void *thread_function(void *arg) 
{
  int i;
 
  printf("A szal indul... \n");
  for ( i=1; i<=5; i++ ) 
  {
    printf("Mellekszal. Elozo: %d. Aktualis: %d\n",delay3(i),i); // Itt erdemes kiserletezni. Hivjuk meg a kulonbozo implementaciokat!
    sleep(1);
  }
  printf("A szal kilep... \n");
  return NULL;
}


int main(void) 
{
  pthread_t mythread, t2;
  int i;  

  if ( pthread_create( &mythread, NULL, thread_function, NULL) ) 
  {
    fprintf(stderr,"Hiba a szal letrehozasaban.\n");
    exit(1);
  }
 if ( pthread_create( &t2, NULL, thread_function, NULL) ) 
  {
    fprintf(stderr,"Hiba a szal letrehozasaban.\n");
    exit(1);
  }


  for ( i=10; i<=15; i++ ) 
  {
    printf("Foszal. Elozo: %d. Aktualis: %d\n",delay3(i),i);
    sleep(1);
  }

  if ( pthread_join ( mythread, NULL ) ) 
  {
    fprintf(stderr,"Hiba a szal megvarasaban.\n");
    exit(1);
  }

if ( pthread_join ( t2, NULL ) ) 
  {
    fprintf(stderr,"Hiba a szal megvarasaban.\n");
    exit(1);
  }

  printf("A foszal kilep... \n");
  return 0;
}

