/* fork2.c - Pelda a fork() hasznalatara. */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

int child_function();
int parent_function(int child_id);

int child_function()
{
  printf("Gyerek folyamat. PID: %d\n",getpid());
  printf("Szulo PID: %d\n\n",getppid());
  exit(0);
}

int parent_function(int child_id)
{
  printf("Szulo folyamat. PID: %d\n",getpid());
  printf("Gyerek ID: %d\n\n",child_id);
  exit(0);
}

int main()
{
  int pid;
  int status;
 
  printf("A program inditasa...\n\n");
  pid=fork();

  if(pid<0)
  {
    printf("fork() hiba.\n\n");
    exit(-1);
  }
  if(pid==0)
  {
    /* A gyermek folyamat - pid 0 */
    child_function();
  }
  else
  {
    /* A szulo folyamat - a pid valtozo a gyermek folyamat 
       azonositoja.*/
    parent_function(pid);
    
    /* Varakozas a gyermekfolyamat vegere */
    wait(&status);
  }

  return 0;
}
