/* getipaddr.c
 * 
 * Internetes névfeloldás példa. A paraméterként kapott hosztnevet
 * IP címmé alakítja. Támogatja az IPv4 és IPv6 címeket is.
 * 
 */

#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <arpa/inet.h>

int main(int argc, char *argv[])
{
  struct addrinfo hints;
  struct addrinfo* res;
  struct addrinfo* p;
  int err;
  char ips[INET6_ADDRSTRLEN];

  if(argc != 2)
  {
    printf("Hasznalat: %s <nev>\n", argv[0]);
    return -1;
  }

  memset(&hints, 0, sizeof(hints));
  hints.ai_family = AF_UNSPEC;
  hints.ai_socktype = SOCK_STREAM;

  err = getaddrinfo(argv[1], NULL, &hints, &res);
  if(err != 0)
  {
    fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(err));
    return -1;
  }

  for(p = res; p != NULL; p = p->ai_next)
  {
    if(p->ai_family == AF_INET)
    {
      if(inet_ntop(AF_INET, &((struct sockaddr_in*)(p->ai_addr))->sin_addr, ips, sizeof(ips)) != NULL)
      {
        printf("IP: %s\n", ips);
      }
    }
    else if(p->ai_family == AF_INET6)
    {
      if(inet_ntop(AF_INET6, &((struct sockaddr_in6*)(p->ai_addr))->sin6_addr, ips, sizeof(ips)) != NULL)
      {
        printf("IP: %s\n", ips);
      }
    }
  }

  freeaddrinfo(res);

  return 0;
}
