/* getipaddr2.c
 * 
 * Internetes névfeloldás példa. A paraméterként kapott hosztnevet
 * IP címmé alakítja. Támogatja az IPv4 és IPv6 címeket is.
 * Szemben a getipaddr.c példával a szöveges IP címeket a
 * getnameinfo() függvénnyel állítja elő.
 * 
 */

#include <stdio.h>
#include <string.h>
#include <netdb.h>

int main(int argc, char *argv[])
{
  struct addrinfo hints;
  struct addrinfo* res;
  struct addrinfo* p;
  int err;
  char ips[INET6_ADDRSTRLEN];

  if(argc != 2)
  {
    printf("Hasznalat: %s <nev>\n", argv[0]);
    return -1;
  }

  memset(&hints, 0, sizeof(hints));
  hints.ai_family = AF_UNSPEC;
  hints.ai_socktype = SOCK_STREAM;

  err = getaddrinfo(argv[1], NULL, &hints, &res);
  if(err != 0)
  {
    fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(err));
    return -1;
  }

  for(p = res; p != NULL; p = p->ai_next)
  {
    if(getnameinfo(p->ai_addr, p->ai_addrlen, 
      ips, sizeof(ips), NULL, 0, NI_NUMERICHOST) == 0)
    {
      printf("IP: %s\n", ips);
    }
  }

  freeaddrinfo(res);

  return 0;
}
