/* helloparam.c
 * 
 * Egyszerű példa a betöltési paraméterek kezelésére.
 * 
 */

#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/kernel.h>
#include <linux/init.h>

/* Létrehozzuk a paramétereknek megfelelő globális változókat. */
static char param1[16] = "hello";
static int param2 = 5;
static int param3[2] = { 1, 2 };
//static int param3num = 2;

/* Makrókkal megadjuk, hogy paraméterként várjuk, ás hogy milyen típussal. */ 
//MODULE_PARM(param1, "s");
module_param_string(param1, param1, 16, 0644);
MODULE_PARM_DESC(param1, "Szoveges parameter");
//MODULE_PARM(param2, "i");
module_param(param2, int, 0644);
MODULE_PARM_DESC(param2, "Szam parameter");
module_param_array(param3, int, NULL, 0644);
//module_param_array(param3, int, &param3num, 0644);
MODULE_PARM_DESC(param3, "Szamtomb parameter");

static int __init hello_init(void)
{
  printk("param1: %s\n", param1);
  printk("param2: %d\n", param2);
  printk("param3: %d, %d\n", param3[0], param3[1]);
  return 0;
}

static void __exit hello_exit(void)
{
  printk("param1: %s\n", param1);
  printk("param2: %d\n", param2);
  printk("param3: %d, %d\n", param3[0], param3[1]);
}

module_init(hello_init);
module_exit(hello_exit);

MODULE_DESCRIPTION("Hello proc");
MODULE_LICENSE("GPL");
