/* hellothread.c
 * 
 * Egyszerű kernelszálas példa.
 *  
 */

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/kthread.h>
#include <linux/delay.h>

struct task_struct* pth;

int mythread(void* arg)
{
  int i = 0;

  while(!kthread_should_stop())
  {
    ssleep(1);
    printk("szal: %d\n", i);
    i++;
  }

  return 0;
}

static int __init hello_init(void)
{
  pth = kthread_run(mythread, NULL, "MyThread");
  return 0;
}

static void __exit hello_exit(void)
{
  kthread_stop(pth);
}

module_init(hello_init);
module_exit(hello_exit);

MODULE_DESCRIPTION("Hello kernelszal");
MODULE_LICENSE("GPL");
