/* select-test.c
 * 
 * A poll függvényt implementáló eszközvezérlő tesztelésére szolgáló program.
 * A program a select használatával demonstrálja, hogy a poll támogatása
 * az eszközvezérlőben egyben a select támogatását is jelenti.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int main(int argc, char* argv[])
{
  int fd;
  int res;
  char buf[128];
  fd_set watchset;
  
  if(argc<2)
  {
    fprintf(stderr, "Hasznalat: %s <allomany>\n", argv[0]);
    return 1;
  }
  
  if((fd=open(argv[1], O_RDONLY | O_NONBLOCK)) < 0)
  {
    perror("open");
    return 1;
  }
  
  FD_ZERO(&watchset);
  FD_SET(fd, &watchset);
  
  if(select(fd + 1, &watchset, NULL, NULL, NULL) < 0)
  {
    perror("select");
    return 1;
  }
  
  if(FD_ISSET(fd, &watchset))
  {
    res = read(fd, buf, sizeof(buf)-1);
    if(res > 0)
    {
      buf[res] = 0;
      printf("%s\n", buf);
    }
    else if(res == 0)
    {
      printf("Nulla byte erkezett.\n");
    }
    else
    {
      perror("read");
      return 1;
    }
  }
  
  return 0;
}
 
