#include "chatclientwindow.h"

ChatClientWindow::ChatClientWindow(QWidget *parent) :
    QWidget(parent)
{
    vLayout = new QVBoxLayout;
    this->setLayout(vLayout);

    txtChatHistory = new QTextEdit;
    txtChatHistory->setReadOnly(true);
    vLayout->addWidget(txtChatHistory);

    hLayout = new QHBoxLayout;

    lblText = new QLabel;
    lblText->setText("zenet:");
    hLayout->addWidget(lblText);

    txtInput = new QLineEdit;
    hLayout->addWidget(txtInput);

    btnSend = new QPushButton;
    btnSend->setText("Klds");
    connect(btnSend, SIGNAL(clicked()), this, SLOT(sendText()));
    hLayout->addWidget(btnSend);

    vLayout->addLayout(hLayout);

    txtChatHistory->append("Szerverkapcsolat mg nem plt ki.");
    txtInput->setDisabled(true);

    socket = new QTcpSocket();
    connect(socket, SIGNAL(connected()), this, SLOT(hostConnected()));
    connect(socket, SIGNAL(readyRead()), this, SLOT(socketReadyRead()));
    socket->connectToHost("localhost", 9937);
}

void ChatClientWindow::sendText()
{
    QString text = txtInput->text();
    txtInput->clear();
    txtChatHistory->append(QTime::currentTime().toString() % " n: " % text);
    socket->write(text.toLatin1());
    socket->flush();
}

void ChatClientWindow::hostConnected(){
    txtChatHistory->clear();
    txtChatHistory->append("Szerverkapcsolat felptve");
    txtInput->setEnabled(true);
}


void ChatClientWindow::socketReadyRead(){
    QString message(socket->readAll());
    txtChatHistory->append(QTime::currentTime().toString() % " " % message);
}
