#include "chatserver.h"

#include <QtCore>
#include <QtNetwork/QTcpServer>
#include <QtNetwork/QTcpSocket>
#include <QtDebug>
#include <QStringBuilder>

ChatServer::ChatServer(QObject *parent) :
    QObject(parent)
{
    tcpServer = new QTcpServer;
    this->clientSockets = new QList<QTcpSocket*>();
    connect(tcpServer, SIGNAL(newConnection()), this, SLOT(newConnection()));
    if (tcpServer->listen(QHostAddress::Any, 9937)){
        qDebug() << "Szerver elindult...";
    } else {
        qDebug() << "hiba";
    }
}

void ChatServer::newConnection(){
    QTcpSocket * socket = tcpServer->nextPendingConnection();
    clientSockets->append(socket);
    connect(socket, SIGNAL(readyRead()), this, SLOT(textReceived()));
    qDebug() <<"kliens ["<< this->clientSockets->size()-1 << "] csatlakozott";
}


void ChatServer::textReceived(){
    QTcpSocket * socket = (QTcpSocket*)sender();
    int index = this->clientSockets->indexOf(socket);
    QString message = "[" % QString::number(index) % "]:" % socket->readAll();
    qDebug() << message;
    QListIterator<QTcpSocket*> iterator(*clientSockets);
    while (iterator.hasNext())
    {
        QTcpSocket * client = iterator.next();
        if (client != socket)
        {
            client->write(message.toLatin1());
        }
    }

}
