#include "customwidget.h"

CustomWidget::CustomWidget(QWidget *parent) :
    QWidget(parent)
{
    currentShape = Rectangle;
    setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Minimum);
}

void CustomWidget::mousePressEvent(QMouseEvent *event){
    currentShape = currentShape == Rectangle ? Ellipse : Rectangle;
    update();
    emit shapeChanged(currentShape);
}

void CustomWidget::paintEvent(QPaintEvent *event){
    QPainter painter(this);

    QPen pen;
    pen.setColor(Qt::blue);
    pen.setWidth(4);
    painter.setPen(pen);
    pen.setJoinStyle(Qt::RoundJoin);

    QBrush brush;
    brush.setColor(Qt::red);
    brush.setStyle(Qt::SolidPattern);
    painter.setBrush(brush);

    switch (currentShape){
        case Rectangle:
            painter.drawRect(0, 0, this->size().width(), this->size().height());
            painter.drawLine(0, 0, this->size().width(), this->size().height() );
            painter.drawLine(0, this->size().height(), this->size().width(), 0);
            break;
        case Ellipse:
            painter.drawEllipse(0, 0, this->size().width(), this->size().height());
            break;
    }
}

QSize CustomWidget::sizeHint() const
{
    return QSize(200, 200);
}
