#include "datasource.h"

DataSource::DataSource(QObject *parent) :
    QObject(parent)
{

}

void DataSource::setDocument(Document *doc){
    this->document = doc;
    timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(timerTimedOut()));
    connect(this, SIGNAL(dataReceived(double)), doc, SLOT(appendData(double)), Qt::QueuedConnection);
    timer->start(1000);
}

void DataSource::timerTimedOut(){
    emit dataReceived((double)(qrand() % 100) / 10.0);
}

void DataSource::stopTimer(){
    this->timer->stop();
}
