#include "diagramview.h"
#include <QtGui>

DiagramView::DiagramView(QWidget *parent) :
    View(parent)
{
    this->setMinimumSize(200, 100);
    buffer = NULL;
}


void DiagramView::paintEvent(QPaintEvent * painEvent){
    QPainter painter(this);
    if (buffer != NULL)
        painter.drawPixmap(rect(), *buffer);
}

void DiagramView::updateView(){
    updateBuffer();
    repaint();
}

void DiagramView::updateBuffer(){
    if (buffer != NULL)
        delete buffer;
    buffer = new QPixmap(rect().size());
    QPainter painter(buffer);
    painter.setBrush(Qt::white);
    painter.fillRect(rect(), Qt::white);
    painter.setPen(Qt::blue);

    QList<double> * data =this->document->getState();
    int barHeight = 10;
    int maxItems = rect().height() / barHeight;
    int index;
    int offset = 0;
    for (index = data->size() - maxItems < 0 ? 0 : data->size() - maxItems; index<data->size(); index++)
    {
        double value = data->at(index);
        painter.drawRect(0, offset*barHeight, (value/10)*rect().width(), barHeight);
        offset ++;
    }
}

void DiagramView::resizeEvent(QResizeEvent * resizeEvent){
    updateBuffer();
    repaint();
}
