#ifndef DOCUMENT_H
#define DOCUMENT_H

#include <QtCore>
#include <QtGui>
#include "view.h"

class View;

class Document : public QObject
{
    Q_OBJECT
public:
    explicit Document(QObject *parent = 0);

    void addView(View * view);
    void removeView(View * view);
    QList<double> * getState();

signals:

public slots:
    void appendData(double value);
    bool openFile(QString fileName);
    bool saveFile();

protected:
    void updateAllViews();

private:
    QList<double> * state;
    QList<View*> *views;
    QString filename;
};

#endif // DOCUMENT_H
