#include "documentwindow.h"
#include <QtGui>

DocumentWindow::DocumentWindow(QWidget *parent):
    QWidget(parent)
{
    this->layout = new QHBoxLayout;
    this->setLayout(layout);
    this->source = NULL;

}

void DocumentWindow::setDocument(Document *doc){
    this->document = doc;
}

void DocumentWindow::addView(View *view){
    this->layout->addWidget(view);
    this->update();

}

Document * DocumentWindow::getDocument(){
    return this->document;
}

void DocumentWindow::setDataSource(DataSource *source){
    this->source = source;
    connect(this, SIGNAL(destroyed()), source, SLOT(stopTimer()));
}

DataSource * DocumentWindow::getDataSource(){
    return this->source;
}
